libxml++: xmlpp::RelaxNGSchema Class Reference

libxml++ 5.6.0

Public Member Functions | Protected Member Functions | List of all members
xmlpp::RelaxNGSchema Class Reference

Represents a RelaxNG schema for validating XML files. More...

`#include <libxml++/relaxngschema.h>`

Inheritance diagram for xmlpp::RelaxNGSchema:
[legend]

## Public Member Functions
| RelaxNGSchema ()
| RelaxNGSchema (_xmlRelaxNG * schema)
| Create a schema from the underlying libxml schema element.
| RelaxNGSchema (const Document * document)
| Create a schema from an XML document.
| RelaxNGSchema (const std::string & filename)
| Create a schema from a schema definition file.
| ~RelaxNGSchema () override
const _xmlRelaxNG * | cobj () const noexcept
| Access the underlying libxml implementation.
_xmlRelaxNG * | cobj () noexcept
| Access the underlying libxml implementation.
void | parse_document (const Document * document) override
| Parse a schema definition from a document.
void | parse_file (const std::string & filename) override
| Parse a schema definition file.
void | parse_memory (const ustring & contents) override
| Parse a schema definition from a string.
Public Member Functions inherited from xmlpp::SchemaBase
| SchemaBase () noexcept
| ~SchemaBase () override
Public Member Functions inherited from xmlpp::NonCopyable
| NonCopyable (const NonCopyable &)=delete
| NonCopyable (NonCopyable &&)=delete
NonCopyable & | operator= (const NonCopyable &)=delete
NonCopyable & | operator= (NonCopyable &&)=delete

## Protected Member Functions
void | parse_context (_xmlRelaxNGParserCtxt * context)
void | release_underlying ()
Protected Member Functions inherited from xmlpp::NonCopyable
| NonCopyable () noexcept
virtual | ~NonCopyable ()

## Detailed Description

Represents a RelaxNG schema for validating XML files.

RelaxNG = REgular LAnguage for XML Next Generation

Since libxml++ 2.38

## Constructor & Destructor Documentation

## ◆ RelaxNGSchema() [1/4]

xmlpp::RelaxNGSchema::RelaxNGSchema | ( |  | ) |

## ◆ RelaxNGSchema() [2/4]

xmlpp::RelaxNGSchema::RelaxNGSchema | ( | _xmlRelaxNG * | schema | ) |
| explicit

Create a schema from the underlying libxml schema element.

Parameters

  schema | A pointer to the libxml schema element. The RelaxNGSchema takes ownership of the _xmlRelaxNG. The caller must not deallocate it.

## ◆ RelaxNGSchema() [3/4]

xmlpp::RelaxNGSchema::RelaxNGSchema | ( | const std::string & | filename | ) |
| explicit

Create a schema from a schema definition file.

The schema must be defined with XML syntax (.rng file). The compact syntax (.rnc file) is not supported.

Parameters

  filename | The URL of the schema.

Exceptions

  xmlpp::parse_error |

## ◆ RelaxNGSchema() [4/4]

xmlpp::RelaxNGSchema::RelaxNGSchema | ( | const Document * | document | ) |
| explicit

Create a schema from an XML document.

Parameters

  document | A preparsed document tree, containing the schema definition.

Exceptions

  xmlpp::parse_error |

## ◆ ~RelaxNGSchema()

xmlpp::RelaxNGSchema::~RelaxNGSchema | ( |  | ) |
| override

## Member Function Documentation

## ◆ cobj() [1/2]

const _xmlRelaxNG * xmlpp::RelaxNGSchema::cobj | ( |  | ) | const
| noexcept

Access the underlying libxml implementation.

## ◆ cobj() [2/2]

_xmlRelaxNG * xmlpp::RelaxNGSchema::cobj | ( |  | ) |
| noexcept

Access the underlying libxml implementation.

## ◆ parse_context()

void xmlpp::RelaxNGSchema::parse_context | ( | _xmlRelaxNGParserCtxt * | context | ) |
| protected

## ◆ parse_document()

void xmlpp::RelaxNGSchema::parse_document | ( | const Document * | document | ) |
| overridevirtual

Parse a schema definition from a document.

If another schema has been parsed before, that schema is replaced by the new one.

Parameters

  document | A preparsed document tree, containing the schema definition.

Exceptions

  xmlpp::parse_error |

Implements xmlpp::SchemaBase.

## ◆ parse_file()

void xmlpp::RelaxNGSchema::parse_file | ( | const std::string & | filename | ) |
| overridevirtual

Parse a schema definition file.

The schema must be defined with XML syntax (.rng file). The compact syntax (.rnc file) is not supported.

If another schema has been parsed before, that schema is replaced by the new one.

Parameters

  filename | The URL of the schema.

Exceptions

  xmlpp::parse_error |

Implements xmlpp::SchemaBase.

## ◆ parse_memory()

void xmlpp::RelaxNGSchema::parse_memory | ( | const ustring & | contents | ) |
| overridevirtual

Parse a schema definition from a string.

The schema must be defined with XML syntax. The compact syntax is not supported.

If another schema has been parsed before, that schema is replaced by the new one.

Parameters

  contents | The schema definition as a string.

Exceptions

  xmlpp::parse_error |

Implements xmlpp::SchemaBase.

## ◆ release_underlying()

void xmlpp::RelaxNGSchema::release_underlying | ( |  | ) |
| protected